(ns minibaldur.core
  (:gen-class)
  (:require [minibaldur.ecs :refer :all]
            [minibaldur.engine :refer :all]))

(defcomponent name)
(defcomponent position)
(defcomponent health)
(defcomponent attack)

(defentity
  (name "Goblin")
  (position {:x 0 :y 0 :z 0})
  (health 10)
  (attack "1d4 + 2"))

(defentity
  (name "Adventurer")
  (position {:x 0 :y 0 :z 0})
  (health 20)
  (attack "1d6 + 3"))

(defn battle-system
  [entity]
  (let [opponent (if (= (name entity) "Goblin")
                   (find-by :name "Adventurer")
                   (find-by :name "Goblin"))]
    (health opponent (max 0 (- (health opponent) (first (roll (attack entity))))))))

(defn do-battle
  []
  (let [goblin (find-by :name "Goblin")
        adventurer (find-by :name "Adventurer")]
    (while (every? pos? [(health goblin) (health adventurer)])
      (run-e battle-system [:name :health]))))

(defn -main
  "I don't do a whole lot ... yet."
  [& args]
  (println "Hello, World!"))
